jQuery(function( $ ){
    /**
     * Demo binding and preparation, no need to read this part
     */
    //borrowed from jQuery easing plugin
    //http://gsgd.co.uk/sandbox/jquery.easing.php
    $.easing.elasout = function(x, t, b, c, d) {
        var s=1.70158;var p=0;var a=c;
        if (t==0) return b;  if ((t/=d)==1) return b+c;  if (!p) p=d*.3;
        if (a < Math.abs(c)) { a=c; var s=p/4; }
        else var s = p/(2*Math.PI) * Math.asin (c/a);
        return a*Math.pow(2,-10*t) * Math.sin( (t*d-s)*(2*Math.PI)/p ) + c + b;
    };
    // back links
    $('a.back').click(function(){
        $(this).parents('div.pane').scrollTo( 0, 800, { queue:true } );
        $(this).parents('div.section').find('span.message').text( this.title );
        return false;
    });
    //just for the example, to stop the click on the links.
    $('ul.links').click(function(e){
        e.preventDefault();
        var link = e.target;
        link.blur();
        if( link.title )
            $(this).parent().find('span.message').text(link.title);
    });
    
    // This one is important, many browsers don't reset scroll on refreshes
    // Reset all scrollable panes to (0,0)
    $('div.pane').scrollTo( 0 );
    // Reset the screen to (0,0)
    $.scrollTo( 0 );
    
    // TOC, shows how to scroll the whole window
    $('#toc a').click(function(){//$.scrollTo works EXACTLY the same way, but scrolls the whole screen
        $.scrollTo( this.hash, 1500, { easing:'elasout' });
        $(this.hash).find('span.message').text( this.title );
        return false;
    });
    
    // Target examples bindings
    // THIS DEMO IS NOT INTENDED TO SHOW HOW TO CODE IT
    // JUST THE MULTIPLE OPTIONS. THIS CODE IS UGLY.
	var $paneTargetAA = $('#pane-targetAA');    
    
    $('#jquery-object_0A').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_01').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(5)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    }); 
	$('#jquery-object_02').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(1)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_03').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(2)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_04').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(3)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_05').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(4)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_06').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_07').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_08').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_09').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_10').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_11').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(0)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_12').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(1)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    }); 
	$('#jquery-object_13').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(2)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_14').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(3)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_15').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(4)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	 $('#jquery-object_16').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(5)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	$('#jquery-object_17').click(function(){
        var $targetAA = $paneTargetAA.find('li:eq(6)');
        $paneTargetAA.stop().scrollTo( $targetAA , 800 );
    });
	
	
	
	
    var $paneTarget = $('#pane-target');
    
    
    $('#jquery-object_a00').click(function(){
        var $target = $paneTarget.find('li:eq(0)');
        $paneTarget.stop().scrollTo( $target , 800 );
    });
	$('#jquery-object_a01').click(function(){
        var $target = $paneTarget.find('li:eq(1)');
        $paneTarget.stop().scrollTo( $target , 800 );
    });
	$('#jquery-object_a02').click(function(){
        var $target = $paneTarget.find('li:eq(1)');
        $paneTarget.stop().scrollTo( $target , 800 );
    });
	$('#jquery-object_a03').click(function(){
        var $target = $paneTarget.find('li:eq(0)');
        $paneTarget.stop().scrollTo( $target , 800 );
    });
	

	
	var $paneTarget2 = $('#pane-target2');
     
    $('#jquery-object_b00').click(function(){
        var $target2 = $paneTarget2.find('li:eq(0)');
        $paneTarget2.stop().scrollTo( $target2 , 800 );
    });
	$('#jquery-object_b01').click(function(){
        var $target2 = $paneTarget2.find('li:eq(1)');
        $paneTarget2.stop().scrollTo( $target2 , 800 );
    });
	
	

	var $paneTarget3 = $('#pane-target3');
     
    $('#jquery-object_c00').click(function(){
        var $target3 = $paneTarget3.find('li:eq(0)');
        $paneTarget3.stop().scrollTo( $target3 , 800 );
    });
	$('#jquery-object_c01').click(function(){
        var $target3 = $paneTarget3.find('li:eq(1)');
        $paneTarget3.stop().scrollTo( $target3 , 800 );
    });
	
	
	var $paneTarget4 = $('#pane-target4');
     
    $('#jquery-object_d00').click(function(){
        var $target4 = $paneTarget4.find('li:eq(0)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d01').click(function(){
        var $target4 = $paneTarget4.find('li:eq(1)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d02').click(function(){
        var $target4 = $paneTarget4.find('li:eq(2)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d03').click(function(){
        var $target4 = $paneTarget4.find('li:eq(1)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d04').click(function(){
        var $target4 = $paneTarget4.find('li:eq(0)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d05').click(function(){
        var $target4 = $paneTarget4.find('li:eq(2)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	$('#jquery-object_d06').click(function(){
        var $target4 = $paneTarget4.find('li:eq(1)');
        $paneTarget4.stop().scrollTo( $target4 , 800 );
    });
	
	
	var $paneTarget5 = $('#pane-target5');
     
    $('#jquery-object_e00').click(function(){
        var $target5 = $paneTarget5.find('li:eq(0)');
        $paneTarget5.stop().scrollTo( $target5 , 800 );
    });
	$('#jquery-object_e01').click(function(){
        var $target5 = $paneTarget5.find('li:eq(1)');
        $paneTarget5.stop().scrollTo( $target5 , 800 );
    });
	$('#jquery-object_e02').click(function(){
        var $target5 = $paneTarget5.find('li:eq(2)');
        $paneTarget5.stop().scrollTo( $target5 , 800 );
    });
	
	
	var $paneTarget6 = $('#pane-target6');
     
    $('#jquery-object_f00').click(function(){
        var $target6 = $paneTarget6.find('li:eq(0)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f01').click(function(){
        var $target6 = $paneTarget6.find('li:eq(1)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f02').click(function(){
        var $target6 = $paneTarget6.find('li:eq(2)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f03').click(function(){
        var $target6 = $paneTarget6.find('li:eq(3)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f04').click(function(){
        var $target6 = $paneTarget6.find('li:eq(4)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f05').click(function(){
        var $target6 = $paneTarget6.find('li:eq(5)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f06').click(function(){
        var $target6 = $paneTarget6.find('li:eq(6)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f07').click(function(){
        var $target6 = $paneTarget6.find('li:eq(7)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f08').click(function(){
        var $target6 = $paneTarget6.find('li:eq(8)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	$('#jquery-object_f09').click(function(){
        var $target6 = $paneTarget6.find('li:eq(9)');
        $paneTarget6.stop().scrollTo( $target6 , 800 );
    });
	
	
	
	var $paneTarget7 = $('#pane-target7');
     
    $('#jquery-object_g00').click(function(){
        var $target7 = $paneTarget7.find('li:eq(0)');
        $paneTarget7.stop().scrollTo( $target7 , 800 );
    });
	$('#jquery-object_g01').click(function(){
        var $target7 = $paneTarget7.find('li:eq(1)');
        $paneTarget7.stop().scrollTo( $target7 , 800 );
    });
	
	
	
	
    
    // Options examples bindings, they will all scroll to the same place, with different options
    function reset_o(){//before each animation, reset to (0,0), skip this.
        $paneOptions.stop(true).attr({scrollLeft:0, scrollTop:0});
    };
	
    var $paneOptions = $('#pane-options');
    
    $('#options-no').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000 );
    });
    $('#options-axis').click(function(){// only scroll horizontally
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { axis:'x' } );
    });
    $('#options-duration').click(function(){// it's the same as specifying it in the 2nd argument
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', { duration: 3000 } );
    });
    $('#options-easing').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 2500, { easing:'elasout' } );
    });
    $('#options-margin').click(function(){//scroll to the "outer" position of the element
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { margin:true } );
    });
    $('#options-offset').click(function(){//same as { top:-50, left:-50 }
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { offset:-50 } );
    });
    $('#options-offset-hash').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { offset:{ top:-5,left:-30 } });
    });
    $('#options-over').click(function(){//same as { top:-50, left:-50 }
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { over:0.5 });
    });
    $('#options-over-hash').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1000, { over:{ top:0.2, left:-0.5 } });
    });
    $('#options-queue').click(function(){//in this case, having 'axis' as 'xy' or 'yx' matters.
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 2000, { queue:true });
    });
    $('#options-onAfter').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 2000, { onAfter:function(){
                $('#options-message').text('Got there!');
            }
        });
    });
    // onAfterFirst exists only when queuing
    $('#options-onAfterFirst').click(function(){
        reset_o(); $paneOptions.scrollTo( 'li:eq(15)', 1600, { 
            queue:true,
            onAfterFirst:function(){
                $('#options-message').text('Got there horizontally!');
            },
            onAfter:function(){
                $('#options-message').text('Got there vertically!');
            }
        });
    });
});